:: branch1 to have fork, two heads, both closed -- shall be recognized as closed
:: branch2 to have fork, two heads, one closed  -- shall be recognized as active
:: branch3 no active head			-- shall be recognized as inactive
:: branch4 to fork, with 1 inactive and 1 active heads
:: branch5 to be closed and reopened
hg init
hg branch branch1
echo a > file1
hg add
hg ci -m "0"
echo b > file1
hg ci -m "1"
:: two revisions on branch1, now need branch2
hg branch branch2
echo c > file1
hg ci -m "2"
:: fork at revision 0, branch1
hg up 0
echo d > file1
hg ci -m "3"
:: pretend we continue work with another head at the same branch
hg up 1
echo e > file1
hg ci -m "4" --close-branch
:: switch to forked
hg up 3
echo f > file1
hg ci -m "5" --close-branch
:: now, both heads of branch1 are closed
:: start branch3
hg branch branch3
echo g > file1
hg ci -m "6"
:: switch to branch2
hg up 2
:: add a revision we'll close *after* we add one more forked
echo h > file1
hg ci -m "7"
hg up 2
echo i > file1
hg ci -m "8"
hg up 7
hg ci -m "9" --close-branch
:: branch2 now has two heads, one closed and one open
:: back to branch3
hg up 6
echo j > file1
hg ci -m "10"
:: start another branch, leaving branch3 inactive
hg branch branch4
:: fork point ...
echo k > file1
hg ci -m "11"
:: ...and inactive head of the branch4
echo l > file1
hg ci -m "12"
hg branch branch5
echo m > file1
hg ci -m "13"
hg ci -m "14" --close-branch
:: fork at root of branch4, activate it
hg up 11
echo n > file1
hg ci -m "15"
:: now re-open closed branch5
hg up 14
echo o > file1
hg ci -m "16"
